<?php

/**
 * @file
 * Template theme and preprocess functions for the flot_views_pie module.
 */

/**
 * Implements template_preprocess_TEMPLATE().
 */
function template_preprocess_views_view_flot_views_pie(&$variables) {
  // View options set by user.
  $options = $variables['view']->style_plugin->options;
  $series = [];
  $view = $variables['view'];
  $label_column = $options['labels'];
  $value_column = $options['values'];
  foreach ($view->result as $row) {
    $series[] = [
      'label' => $view->field[$label_column]->getValue($row),
      'data' => $view->field[$value_column]->getValue($row),
    ];
  }

  // Update options for twig.
  $variables['flot_views_pie'] = [
    '#type' => 'flot',
    '#data' => $series,
    '#options' => ['series' => ['pie' => ['show' => TRUE]]],
  ];
}

/**
 * Implements theme_TEMPLATE().
 */
function theme_views_view_flot_views_pie($variables) {
  $output = [
    'flot_views_pie' => $variables['flot_views_pie'],
  ];
  return drupal_render($output);
}
