<?php

/**
 * @file
 * Template, theme, and preprocess functions for the flot_views_time mosule.
 */

/**
 * Implements template_preprocess_TEMPLATE().
 */
function template_preprocess_views_view_flot_views_time(&$variables) {
  // View options set by user.
  $options = $variables['view']->style_plugin->options;

  // Initialize the data variable.
  $data = [];
  $view = $variables['view'];

  // The actual x-y values for the one series.
  $values = [];
  $x_column = $options['x'];
  $y_column = $options['y'];
  if ($options['points'] == 1) {
    $series['points'] = ['show' => TRUE];
  }
  if ($options['lines'] == 1) {
    $series['lines'] = ['show' => TRUE];
  }
  foreach ($view->result as $row) {
    $datetime_text = $view->field[$x_column]->getValue($row);

    // Sometimes datetimes are unix timestamps, and some times they are
    // ISO strings. There has to be a better way to do this.
    $datetime_stringed_int = '' . intval($datetime_text);
    //If these are equal, we had an int in the database.
    if ($datetime_text == $datetime_stringed_int) {
      $datetime_text = '@' . $datetime_text;
    }
    $datetime_object = new DateTime($datetime_text, new DateTimeZone('UTC'));
    $datetime_object->setTimezone(new DateTimeZone('America/New_York'));

    $unix_time = $datetime_object->getTimestamp();
    $values[] = [
      // Convert unix time to JS time (seconds to milliseconds)
      $unix_time * 1000,
      $view->field[$y_column]->getValue($row),
    ];
  }
  $series['data'] = $values;
  $data[] = $series;
  // Update options for twig.
  $options = [
    'xaxis' => ['mode' => 'time'],
  ];
  $variables['flot_views_time'] = [
    '#type' => 'flot',
    '#data' => $data,
    '#options' => $options,
  ];
}

/**
 * Implements theme_TEMPLATE().
 */
function theme_views_view_flot_views_time($variables) {
  $output = [
    'flot_views_time' => $variables['flot_views_time'],
  ];
  return drupal_render($output);
}
